having udevsend as hotplug handler breaks firmware loading

Bug #14741 reported by Guilherme Salgado on 2005-03-31
18
Affects Status Importance Assigned to Milestone
hotplug (Ubuntu)
Medium
Scott James Remnant (Canonical)

Bug Description

I just upgraded to hoary and my atmel usb device stopped working because it
failed to load the firmware.
If I set /sbin/hotplug as the hotplug handler, it works again.

Looks like it's already fixed in debian:
http://lists.debian.org/debian-kernel/2005/03/msg00232.html

Matt Zimmerman (mdz) wrote :

It's working fine here; please provide a detailed explanation of the problem
(including error messages).

The bug that you reference says that it deals with firmware loading under old
kernels. What kernel are you running? Which versions of hotplug and udev do
you have installed?

Guilherme Salgado (salgado) wrote :

I have linux-image 2.6.10-31, hotplug 0.0.20040329-16ubuntu, udev
0.050-3ubuntu7. atmel-firmware 1.0-0ubuntu1 and at76c503a-source 0.12.beta19-4.

This is what /var/log/messages says when plugging the usb device using udevsend
as hotplug handler:
Mar 30 22:38:39 evair kernel: usb 1-1: new full speed USB device using uhci_hcd
and address 3
Mar 30 22:38:40 evair kernel: /usr/src/modules/at76c503a/at76_usbdfu.c: USB Devi
ce Firmware Upgrade (DFU) handler v0.12beta22-fw_dwl loading
Mar 30 22:38:40 evair kernel: /usr/src/modules/at76c503a/at76c503.c: Generic Atm
el at76c503/at76c505 routines v0.12beta22-fw_dwl
Mar 30 22:38:40 evair kernel: /usr/src/modules/at76c503a/at76c503-fw_skel.c: Atm
el at76c505 (RFMD 2958) Wireless LAN Driver v0.12beta22-fw_dwl loading
Mar 30 22:38:50 evair kernel: at76c505-rfmd2958: probe of 1-1:1.0 failed with er
ror -14
Mar 30 22:38:50 evair kernel: usbcore: registered new driver at76c505-rfmd2958
Mar 30 22:38:51 evair usb.agent[8769]: at76c505-rfmd2958: loaded successfully

After this, the device is not working.

Now I change the hotplug handler to /sbin/hotplug, plug the device again and got
this in /var/log/messages:
Mar 30 22:39:28 evair kernel: usb 1-1: new full speed USB device using uhci_hcd
and address 5
Mar 30 22:39:28 evair kernel: /usr/src/modules/at76c503a/at76c503.c: $Id: at76c5
03.c,v 1.72 2004/10/19 20:45:25 jal2 Exp $ compiled Mar 29 2005 23:04:19
Mar 30 22:39:28 evair kernel: /usr/src/modules/at76c503a/at76c503.c: firmware ve
rsion 1.101.0 #86 (fcs_len 4)
Mar 30 22:39:28 evair kernel: /usr/src/modules/at76c503a/at76c503.c: device's MA
C 00:0c:41:58:d5:cb, regulatory domain ETSI (Europe - (Spain+France) (id 48)
Mar 30 22:39:28 evair kernel: /usr/src/modules/at76c503a/at76c503.c: registered
wlan0

And now I have wlan0 working.

Matt Zimmerman (mdz) wrote :

Use:

 dpkg-query -W --showformat '${Version}\n' hotplug

to get the full hotplug version number; the version number you supplied has been
truncated.

Guilherme Salgado (salgado) wrote :

salgado@evair [src]$ dpkg-query -W --showformat '${Version}\n' hotplug
0.0.20040329-16ubuntu17

Jeff Bailey (jbailey) wrote :

The Debian bug report close notification seems to indicate that running a 2.6.10
(the default Hoary kernel) should fix this. Are you running an older kernel?

Tks,
Jeff Bailey

Guilherme Salgado (salgado) wrote :

Yes, I'm using linux-image 2.6.10-31, from hoary.

This bug is confirmed to exist with the GO7007 USB driver as well. Several
users have reported it and I can reproduce it on a fresh Hoary RC install. Any
driver that requires the kernel firmware loader is broken.

Markus Posch (markus-posch) wrote :

(In reply to comment #7)
> This bug is confirmed to exist with the GO7007 USB driver as well. Several
> users have reported it and I can reproduce it on a fresh Hoary RC install. Any
> driver that requires the kernel firmware loader is broken.

I'm using a Toshiba Sattelite P20 with Kubuntu 5.04 (I know its not released).

I want to use the dec3000s

The drivers are installed and hotplug is enabled in the kernel

when i connecet the dec i get this in dmesg:

Mar 24 19:27:38 localhost kernel: usb 4-1: new full speed USB device using
uhci_hcd and address 2
Mar 24 19:27:48 localhost usb.agent[7740]: ttusb_dec: loaded successfully
Mar 24 19:27:48 localhost kernel: ttusb_dec: Firmware 1.15<3>ttusb_dec_boot_dsp:
Firmware (dvb-ttusb-dec-3000s.fw) unavailable.

is this the same problem?
how can i solve it?

Bill Tompkins (bugreports) wrote :

I believe that this is the same as Debian bug 302990:
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=302990
Hopefully an upgrade to udev 0.56-2 will fix it (when that gets into Ubuntu)?

In the meantime, a workaround that works for me:

   # get a root shell

sudo bash -l

   # change the hotplug mechanism to /proc/sys/kernel/hotplug:

echo "/sbin/hotplug" > /proc/sys/kernel/hotplug

   # plug in your USB device now. wait a few seconds...

   # now revert your hotplug script to what it was before:

echo "/sbin/udevsend" > /proc/sys/kernel/hotplug

exit

Jeff Bailey (jbailey) wrote :

(In reply to comment #9)
> I believe that this is the same as Debian bug 302990:

0.056-2ubuntu2 is currently in breezy. Because this isn't a usual setup for
udev, it doesn't seem likely that we'd try to update it for Hoary.

I'll leave the bug open until I know for certain that the new version fixes it.

Bill Tompkins (bugreports) wrote :

Jeff, I'm a little confused what you mean by "this is not a usual setup for
udev". I've got a fully patched Hoary system, and when I plug my Bluetooth
dongle in, it doesn't work. It used to work fine under Warty.

Is there something I should do in order to have a "usual setup"?

Thomas Hood (jdthood) wrote :

*** Bug 19097 has been marked as a duplicate of this bug. ***

I'm reasonably sure this was just a temporary problem -- I tripped it when I was
playing back in Mataro and definitely remember it being fixed in both the
kernel and udev.

salgado, if you upgrade to the latest Breezy (Colony 5) and leave udevsend as
the hotplug handler, are things fixed?

(In fact, setting the handler to be hotplug now could really break things as
udevd will receive the event via the uevent netlink socket and process it as well)

Salgado doesn't have that wireless card anymore.

I've not seen any recent duplicate of this bug, and we have plenty of ipw2[12]00
users on breezy now.

As mentioned above, I remember this being a problem and being fixed -- and
actually not using udevsend as your hotplug handler will cause you all sorts of
problems in breezy.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.